



// sending data via RTFIFO1 !!!




// modified by Uwe Damm, for enabling RTLinux-2.3



#undef __NO_VERSION__



int g_val;
int g_sendval;		// value, when sending message, to proove, that answertime corresponds to sendtime
int g_starthrtime;


int g_maxtime,g_mintime;




/*
    rtnet/module/rt_echo_client/rt_echo_client.c
    module that tests echo capability of server

    rtnet - real-time networking subsystem
    Copyright (C) 1999,2000 Zentropic Computing, LLC

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#define FREQ            1                   // Basic frequency in Hz
#define NTASKS          1

#define TICK_PERIOD	1000000

#include <linux/module.h>

#include <rtnet/rtnet.h>

#ifdef CONFIG_RTNET_RTAI
#include <rtai/rtai.h>
#include <rtai/rtai_sched.h>
#endif


#ifdef CONFIG_RTNET_RTL
#include <rtl.h>
#include <rtl_sched.h>
#endif

#include <rtl_fifo.h>


void *process(void * arg);

#ifdef CONFIG_RTNET_RTAI
RT_TASK rt_task;
#endif

#ifdef CONFIG_RTNET_RTL
pthread_t g_rttask;
#endif


#ifdef CONFIG_RTNET_RTL
	#define rt_printk rtl_printf
#endif



// send one packet per second to server
//#define PERIOD 1000000000
//#define PACKETSIZE 32

int period=1000000000;	// in nanoseconds
int size=16;
MODULE_PARM(period,"i");
MODULE_PARM(size,"i");




/* hard coded IP address 192.168.0.1 */
#define SERV_ADDR 0x0100a8c0
// 10.0.48.101  (for trying switched-network)
//#define SERV_ADDR 0x6530000a

#define SERV_PORT 7

static int sock;
static struct sockaddr_in servaddr;

unsigned long tsc1,tsc2;

void *process(void * arg)
{
//	char *sendline="this is a test";

	char sendline[size];
	int i;

	int ret;

	for(i=0;i<size;i++)
	{
		sendline[i]='a';
	}
	sendline[size-1]=0;


	rt_printk("task started\n");
	while(1){
#ifdef CONFIG_RTNET_RTAI
		rt_task_wait_period();
#endif
#ifdef CONFIG_RTNET_RTL
		pthread_wait_np();
#endif

//		rdtscl(tsc1);

		g_starthrtime=gethrtime();
		g_sendval=g_val++;
		ret=rt_sendto(sock,sendline,strlen(sendline),0,
			(struct sockaddr *)&servaddr,sizeof(servaddr));
//		rt_printk("sendto()=%d\n",ret);
	}
}

int echo_rcv(int s,void *arg)
{
	static int l_cnt=0;
	static int l_diffmin=2000000000;
	static int l_diffmax=0;
	static int l_sumcnt=0;
	static int l_diffsum=0;
//	rdtscl(tsc2);
//	rt_printk("rcv diff=%ld\n",tsc2,tsc2-tsc1);




	unsigned int l_difftime;
	char buf[100];

//	rtl_printf("echo_rcved\n");
	l_difftime=(unsigned int)(gethrtime()-g_starthrtime);

	if(l_difftime<l_diffmin)
		l_diffmin=l_difftime;
	if(l_difftime>l_diffmax)
		l_diffmax=l_difftime;

	l_diffsum+=l_difftime;
	l_sumcnt++;

// each 2 seconds send message!
	l_cnt++;
	if(!(l_cnt % (2000000000/period)))
	{

		sprintf(buf
			,"l_cnt %d g_sendval %d g_min %d max %d avrg %d\n"
			,l_cnt,g_sendval
			,l_diffmin,l_diffmax
			,l_diffsum/(l_sumcnt?l_sumcnt:1)
			);

//		sprintf(buf,"%d %d\n", l_cnt, l_difftime);
		rtf_put(1,buf,strlen(buf));


		if(l_diffmax>g_maxtime)
			g_maxtime=l_diffmax;
		if(l_diffmin<g_mintime)
			g_mintime=l_diffmin;

		l_sumcnt=0;
		l_diffsum=0;
		l_diffmax=0;
		l_diffmin=2000000000;
	}
	return 0;
}



int init_module(void)
{
	int ret;


	g_sendval=g_val=0;

	g_maxtime=0;
	g_mintime=2000000000;


#if 0			// its not used
	RTIME tick_period;
#endif

	// set up sending
	
	ret=rtf_destroy(1);
//	rtl_printf("rtf_destroy=%d\n",ret);

/* ZOIS: H parakatw grammn egive sxoleio giati...*/
// xtupaei	ret=__rtf_create(1,10000);
	rtl_printf("rtf_create=%d\n",ret);

	sock=rt_socket(AF_INET,SOCK_DGRAM,0);

	rtl_printf("CLIENT: sock=%d\n",sock);


	memset(&servaddr,0,sizeof(servaddr));
	servaddr.sin_family = AF_INET;
	servaddr.sin_port = 0;
	servaddr.sin_addr.s_addr = htonl(INADDR_ANY);

	ret=rt_bind(sock,(struct sockaddr *)&servaddr,sizeof(servaddr));
//	printk("rt_bind=%d\n",ret);

	memset(&servaddr,0,sizeof(servaddr));
	servaddr.sin_family = AF_INET;
	servaddr.sin_port = htons(SERV_PORT);
	servaddr.sin_addr.s_addr = SERV_ADDR;

	// set up receiving

	rt_socket_callback(sock,echo_rcv,NULL);

	// set up task

//	rt_printk("starting task\n");

#if 0
	tick_period = 
#endif
#ifdef CONFIG_RTNET_RTAI
	start_rt_timer(nano2count(TICK_PERIOD));
	ret=rt_task_init(&rt_task,(void *)process,0,4096,0,0,NULL);
	printk("rt_task_init returned %d\n",ret);
	ret=rt_task_make_periodic_relative_ns( &rt_task, 1000000, 1000000000);
	printk("rt_task_make_periodic returned %d\n",ret);
#endif
#ifdef CONFIG_RTNET_RTL
	ret=pthread_create(&g_rttask,NULL,process,(void *)0);
//	printk("rt_task_init returned %d\n",ret);
	ret=pthread_make_periodic_np( g_rttask, gethrtime(), period);
//	printk("pthread_make_periodic  returned %d\n",ret);
#endif

	rtl_printf("rt_echo_client started!!\n");
	rtl_printf("  period=%d, size=%d\n",period,size);
	rtl_printf("server=%d.%d.%d.%d\n",
			(SERV_ADDR>>0)&0xff,
			(SERV_ADDR>>8)&0xff,
			(SERV_ADDR>>16)&0xff,
			(SERV_ADDR>>24)&0xff);



	return 0;
}


void cleanup_module(void)
{
	rtf_destroy(1);


	rtl_printf("max=%d, min=%d\n",g_maxtime,g_mintime);

#ifdef CONFIG_RTNET_RTAI
	stop_rt_timer();
	rt_task_delete(&rt_task);
#endif

#ifdef CONFIG_RTNET_RTL
	pthread_delete_np(g_rttask);
#endif

	rtl_printf("client STOPED\n");


	rt_close(sock);
}


