



// changes by Uwe Damm



#ifdef CONFIG_RTNET_RTL
#define rt_printk rtl_printf
#endif



/*
    linux/net/rt/echo_server.c
    RT networking UDP echo server (port 7)

    Linux RT networking
    Copyright (C) 1999,2000 Zentropic Computing, LLC

    Author:	David Schleef <ds@stm.lbl.gov>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <linux/kernel.h>
#include <linux/module.h>
//#include <linux/socket.h>
//#include <linux/errno.h>



// struct pt_regs define ???
#include <linux/netdevice.h>





//#include <linux/etherdevice.h>
//#include <linux/init.h>
//#include <linux/ip.h>
//#include <linux/udp.h>
//#include <linux/skbuff.h>

#include <rtnet/rtnet.h>

#include <asm/io.h>


#define ECHO_PORT 7

//#define DEBUG 1
#ifdef DEBUG
#undef DEBUG
#endif

//static struct rtsocket *echo_sock;
static int echo_sock;

#define BUFSZ 1025


#warning "testmessagefromservermodulecompiling\n\n"


void bug(unsigned char l_value)
{
	outb(l_value,0x378);
}

char buffer[BUFSZ];

static int echo_rcv(int s,void *arg)
{
	int ret;
	struct msghdr msg;
	struct iovec iov;
	struct sockaddr_in addr;

	static int flag=0;


	flag++;		// while be decreased at end of function


//	rtl_printf("echo_rcv was started(UWE)\n");

	memset(&msg,0,sizeof(msg));
	iov.iov_base=buffer;
	iov.iov_len=BUFSZ;
	msg.msg_name=NULL;
	msg.msg_iov=&iov;
	msg.msg_iovlen=1;
	msg.msg_control=NULL;
	msg.msg_controllen=0;
	msg.msg_name=&addr;
	msg.msg_namelen=sizeof(addr);


// somewhere in next command is hangupBUG
// it crashes in
//    spin_lock_irqsave
//  called by:
//    skb_dequeue (include/linux/skbuff.h
//  called by
//   rt_udp_recvmsg
//  called by
//   rt_recvmsg  (via sock->ops->recvmsg )

//   WHAT does spin_lock_irqsave?????
// it is #defined in asm/spinlock.h, saving registers, and doing a 

	ret=rt_recvmsg(echo_sock,&msg,0);


	buffer[BUFSZ-1]=0;


	if(ret>0)
	{
		if(flag==1)
			bug(96);
		else
			bug(3);

//		rt_printk("echo rcv from %08x.%d\n",(int)ntohl(addr.sin_addr.s_addr),(int)ntohs(addr.sin_port));
//		rtl_printf("send: bufferadr=%p, msg.msg_iov->iov_base=%p\n",buffer,msg.msg_iov->iov_base);
//		rtl_printf("uweprint: echorcv --> sendmsg:%s\n",msg.msg_iov->iov_base);


// rt_recvmsg seems to change the value of 'iov_base'!!!
		iov.iov_base=buffer;
		msg.msg_iov->iov_len=strlen(buffer);
		ret=rt_sendmsg(echo_sock,&msg,0);
	} // if(ret>0)
	else
	{
		if(flag==1)
			bug(112);
		else
			bug(7);
	}

	flag--;


	return 0;
}


int init_module(void)
{
	struct sockaddr_in addr;
	int res;

	echo_sock = rt_socket(AF_INET,SOCK_DGRAM,0);


	rtl_printf("rt_socket() --> %d\n",echo_sock);


	memset(&addr,0,sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_port = htons(ECHO_PORT);
	addr.sin_addr.s_addr = htonl(INADDR_ANY);

	res=rt_bind(echo_sock,(struct sockaddr *)&addr,sizeof(addr));
	rtl_printf("rt_bind() --> %d\n",res);

	res=rt_socket_callback(echo_sock,echo_rcv,NULL);
	rtl_printf("rt_socket_callback() -->%d\n",res);

	printk("rt_echo_server started\n");

	bug(0);

	return 0;
}

void cleanup_module(void)
{
	printk("rt_echo_server stopped\n");

	rt_close(echo_sock);
	bug(0);
}



