#ifdef CONFIG_RTNET_RTL
#define __NO_VERSION__
#endif
/*
    linux/net/rt/rtnet_syms.c
    RT network interface

    Linux RT networking
    Copyright (C) 1999 Zentropic Computing, LLC

    Author:	David Schleef <ds@stm.lbl.gov>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <linux/kernel.h>
#include <linux/socket.h>
#include <rtnet/rtnet.h>
#include <linux/errno.h>
#include <linux/module.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>

#include <asm/uaccess.h>

#ifdef CONFIG_RTNET_PRINTK
EXPORT_SYMBOL(__rt_printk);
#endif

EXPORT_SYMBOL(rt_socket_callback);

EXPORT_SYMBOL(rt_accept);
EXPORT_SYMBOL(rt_bind);
EXPORT_SYMBOL(rt_close);
EXPORT_SYMBOL(rt_connect);
EXPORT_SYMBOL(rt_listen);
EXPORT_SYMBOL(rt_recv);
EXPORT_SYMBOL(rt_recvfrom);
EXPORT_SYMBOL(rt_recvmsg);
//EXPORT_SYMBOL(rt_send);
EXPORT_SYMBOL(rt_sendmsg);
EXPORT_SYMBOL(rt_sendto);
EXPORT_SYMBOL(rt_socket);

EXPORT_SYMBOL(rtnetif_rx);
EXPORT_SYMBOL(rtnetif_wake_queue);
EXPORT_SYMBOL(rt_dev_alloc);
EXPORT_SYMBOL(rt_eth_header);
EXPORT_SYMBOL(alloc_rtskb);
EXPORT_SYMBOL(__kfree_rtskb);

EXPORT_SYMBOL(rtnet_request_irq);
EXPORT_SYMBOL(rtnet_free_irq);

/********* ZOIS ********/
EXPORT_SYMBOL(rtsocket_alloc);
EXPORT_SYMBOL(rt_inet_add_protocol);
EXPORT_SYMBOL(rt_ip_route_output);
EXPORT_SYMBOL(rt_ip_build_xmit);
EXPORT_SYMBOL(rt_dev_get);

